// sd.c, for Digital Mars under Windows

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include "klrlfn.i"

#define MAX 200

char *help = "usage:  sd path[\\dirspec]   --shows subdirs (up to 14 chars)\n";
char stack[MAX][15];

int qcmp(const void *s1, const void *s2)
  {
  return stricmp((char *)s1,(char *)s2);
  }

int main(int argc, char *argv[])
  {
  int i, nstack=0;
  char path[MAXPATH];
  struct lfnFIND *ffb;
  if(argc<2) strcpy(path,".");
  else
    {
    if(stricmp(argv[1],"/?")==0) { printf(help); return 0; }
    strcpy(path,argv[1]);
    }
  if(!strchr(path,'*'))
    {
    if(path[strlen(path)-1]!='\\') strcat(path,"\\");
    strcat(path,"*.*");
    }
  ffb=lfnfindfirst(path);
  while((ffb!=NULL)&&(nstack<MAX))
    {
    if((ffb->ff_attrib&FA_DIREC)&&
      !(ffb->ff_attrib&FA_HIDDEN)&&
      (ffb->ff_longname[0]!='.'))
      {
      ffb->ff_longname[14]='\0';
      strcpy(stack[nstack++],(char *)ffb->ff_longname);
      }
    ffb=lfnfindnext();
    }
  lfnfindclose();
  if(!nstack) { printf("no subdirectories\n"); return 0; }
  qsort(stack,nstack,15,qcmp);
  for(i=0;i<nstack;i++)
    {
    if(i&&!(i%5)) printf("\n");
    printf("%-15s",stack[i]);
    }
  if(nstack==MAX) printf("\nstop %d limit\n",MAX);
  return 0;
  }
